-module(service_admin_extra_upload).

-include("ejabberd_commands.hrl").

-export([commands/0]).

-ignore_xref([commands/0, get_urls/5]).

-spec commands() -> [ejabberd_commands:cmd()].
commands() -> [
    #ejabberd_commands{
        name     = http_upload,
        tags     = [http, upload],
        desc     = "Generate upload/download URLs for the file",
        longdesc = "Returns upload/download URLs generated by mod_http_upload. Example:\n"
                   " mongooseimctl http_upload localhost tmp.txt 5 '' 60",
        module   = mod_http_upload_api,
        function = get_urls_mongooseimctl,
        args     = [{domain, binary}, {file_name, binary}, {size, integer},
                    {content_type, binary}, {timeout, integer}],
        result   = {res, restuple}
    }
].
